
Installing and Starting
=====================


To start the sentiment analysis servers, there are two steps:

1. Start the Sentiment Classification Server
2. Start the API Layer

As an optional third step:

3. Start the visualization applications. 

## Start the Sentiment Classification Server:

Starting from the root of the code base:

```
$ ls -l
README.md
apilayer
apps
dataset
sentiment_server
```

1. Change directory to sentiment_server: ```$ cd sentiment_server/```
2. Start the sentiment server: ```$ python main.py```

This will start the server on ```http://localhost:7000/``` and it will listen for requests. 
This server should be started in ```screen``` if possible.

To see help run the following: ```python main.py -h```.


## Start the API Layer Server:

Again, starting from the root of the code base:

```
$ ls -l
README.md
apilayer
apps
dataset
sentiment_server
```

1. Change directory to apilayer: ```$ cd apilayer/```
2. Start the API Layer: ```$ npm start```

This will start the server on ```http://localhost:8088/``` and it will per default send requests
to ```http://localhost:7000/```. This server should be started in ```screen``` with ```forever``` if possible.

If you want to change the connection point to the sentiment server, this can be done by changing the ```config/default.js``` file. 
To change the port, env varibales can be used:

```
$ export PORT=7007
$ npm start
Express server listening on port 7007 in development mode
```

## Installing and starting SentiMap

Change directory to SentiMap from root: ```$ cd apps/sentimap/```

All dependancies are allready installed in both the ```node_modules``` and ```app/scripts/vendor/``` directory.

If you started the API Layer on a another address than ```http://localhost:8088```, you need to change the URL for the API Layer in the ```sntwitter``` dependency in ```node_modules/sntwitter/lib/keys.js```.

Start the server side code using: ```$ npm start```

Update the current values:

```
rest_base: 'http://localhost:8088',
search_base: 'http://localhost:8088',
stream_base: 'http://localhost:8088',
user_stream_base: 'http://localhost:8088',
site_stream_base: 'http://localhost:8088'
```

## Installing and starting SentiSearch

Change directory to SentiGraph from root: ```$ cd apps/sentigraph/```

Just open the ```index.html``` file. 

If the API Layer is on another URL, the URL parameter on line 7 of ```chart.js``` have to be updated. 


## Installing and starting SentiStack

Change directory to SentiStack from root: ```$ cd apps/sentistack/```

Just open the ```index.html``` file. 

If the API Layer is on another URL, the URL parameter on line 9 of ```js/app.js``` have to be updated. 

